from __future__ import annotations

from enum import Enum
from typing import Any, Callable

class _Annotation(Enum):
    Str = "str"
    Bool = "bool"
    Int = "int"
    Float = "float"
    List = "list"
    Dict = "dict"

def main(): ...

class _Client:
    @staticmethod
    def default() -> _Client: ...
    def run(self, job: _Job, args: list[_Arg]) -> _JobHandle: ...

class _Function:
    @staticmethod
    def from_code(py_name: str, py_code: str, py_args: list[_Param]): ...
    @staticmethod
    def from_callable(py_name: str, py_callable: Callable, py_args: list[_Param]): ...

class _Job:
    name: str
    main: _Function | None
    @staticmethod
    def new(name: str, env: _Env) -> _Job: ...

class _JobHandle:
    job_id: str
    job_url: str
    space_id: str

class _Env:
    @staticmethod
    def new(python_version: str) -> _Env: ...
    @property
    def environ(self) -> dict[str, str]: ...
    @environ.setter
    def environ(self, env: dict[str, str]): ...
    def include(self, paths: list[str]): ...
    def pip_install(self, requirements: list[str]): ...
    def dump(self) -> dict[str, str]: ...

class _Value:
    def __init__(self, value: Any): ...

class _Arg:
    def __init__(self, name: str, value: _Value): ...

class _Param:
    def __init__(self, name: str, annotation: _Annotation): ...
    @property
    def name(self) -> str: ...
    @property
    def annotation(self) -> _Annotation: ...
